package {

	/**
	 * @author nicoptere
	 * http://en.nicoptere.net/
	 */
	 import flash.geom.Point;
	public class Spline 
	{
		
		/**
		 * function to smooth a set of points, it might really comme in handy.
		 * you can create pathes for sprites or particles with very few points
		 * @param	handles : a set of points
		 * @param	smoothness : the number of steps along the Quadratic Bezier curve between 3 points
		 * ranged from Number.MIN_VALUE ( so smooth the computer will crash) to 1 (a straight line)
		 * 
		 * * @return	an array of the smooth curve's points
		 */
		static public function QuadraticPath( handles:Array, smoothness:Number = .1 ):Array
		{
			Number.MIN_VALUE
			var tmp:Array = new Array();
			
			var i:int = 0;
			
			var p0:Point = new Point(0,0);
			var p1:Point = new Point(0,0);
			var p2:Point = new Point(0,0);
			
			
			var t:Number;
			var t2:Number;
			var t3:Number;
			var t4:Number;
			var X:Number;
			var Y:Number;
			
			var j:Number = 0;
			
			while( i < handles.length )
			{
				
				//p0
				if( i == 0 )
				{
					
					p0.x = handles[ i ].x;
					p0.y = handles[ i ].y;
					
				}
				else
				{
					
					p0.x = ( handles[ i - 1 ].x + handles[ i ].x ) / 2;
					p0.y = ( handles[ i - 1 ].y + handles[ i ].y ) / 2;
					
				}
				//p1
				p1.x = handles[ i ].x;
				p1.y = handles[ i ].y;
		
				//p2	
				if( i == handles.length - 1 )
				{
					
					p2.x = handles[ i ].x;
					p2.y = handles[ i ].y;
					
				}	
				else
				{
					
					p2.x = ( handles[ i + 1 ].x + handles[ i ].x ) / 2;
					p2.y = ( handles[ i + 1 ].y + handles[ i ].y ) / 2;
					
				}
				
				
				j = 0;
				while( j < 1 )
				{
					
					t  = 1 - j;
					t2 = t * t;
					t3 = 2 * j * t;
					t4 = j * j;
					
					X = t2 * p0.x + t3 * p1.x + t4 * p2.x;
					Y = t2 * p0.y + t3 * p1.y + t4 * p2.y;
					
					tmp.push( new Point( X, Y ) );
					j += smoothness;
					
				}
				
				i++;
			}
			
			return tmp;
			
		}
		
	}
}
